<?php
// Author: Joshua Uziel
// Copyright 2001, Sun Microsystems, Inc.  All rights reserved.
// $Id: bandwidthAdd.php,v 1.2 2001/12/20 02:23:15 uzi Exp $

include("ServerScriptHelper.php");
include("Product.php");

$helper = new ServerScriptHelper();
$cce = $helper->getCceClient();
$product = new Product($cce);
$factory = $helper->getHtmlComponentFactory("base-bandwidth", "/base/bandwidth/bandwidthHandler.php");
$i18n = $helper->getI18n("base-bandwidth");

$block = $factory->getPagedBlock("bandwidthSettings");

$page = $factory->getPage();

$netobj = $cce->findSorted("Network", "ipaddr");
$bwobj  = $cce->findSorted("Bandwidth", "ipaddr");

// Get the IP addresses for the network objects.
$netip = array();
for ($i=0; $i<sizeof($netobj); $i++) {
	$obj = $cce->get($netobj[$i]);
	if ($obj["ipaddr"] && $obj["enabled"]) {
		array_push($netip, $obj["ipaddr"]);
	}
}

// Get the IP addresses for already configured bandwidth objects.
$bwip = array();
for ($i=0; $i<sizeof($bwobj); $i++) {
	$obj = $cce->get($bwobj[$i]);
	if ($obj["ipaddr"]) {
		array_push($bwip, $obj["ipaddr"]);
	}
}

// Differenciate the network IPs from the bandwidth IPs.  We pass it
// through array_values() because array_diff preserves the keys.
$ipaddr = array_values(array_diff($netip, $bwip));

$ipselect = $factory->getMultiChoice("ipAddressField", $ipaddr);
$ipselect->setSelected(0, true);

$block->addFormField( $ipselect, $factory->getLabel("ipAddressField"));

$block->addFormField(
	$factory->getInteger("bwLimitField"),
	$factory->getLabel("bwLimitField")
);

$errors = $helper->getErrors();
$block->processErrors($errors);

$block->addButton($factory->getSaveButton($page->getSubmitAction()));
$block->addButton($factory->getCancelButton("/base/bandwidth/bandwidthList.php"));

if (!sizeof($ipaddr)) {
	$errors = array(new Error('[[base-bandwidth.allLimited]]'));
	print $helper->toHandlerHtml("/base/bandwidth/bandwidthList.php", $errors);
} else {
	print($page->toHeaderHtml());
	print($block->toHtml());
	print($page->toFooterHtml());
}

$helper->destructor();
?>
